/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of bt.xs. Do not edit this file, edit bt.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "bt.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#ifndef PERL_UNUSED_ARG
# define PERL_UNUSED_ARG(x) ((void)x)
#endif

static int signals[] = {
    SIGILL,
    SIGFPE,
    SIGBUS,
    SIGSEGV,
    SIGTRAP,
    SIGABRT,
    SIGQUIT
};

static char perl_path[PATH_MAX], gdb_path[PATH_MAX];

static void
register_sighandler (void (*handler)(int))
{
    unsigned int i;
    for (i = 0; i < sizeof(signals) / sizeof(signals[0]); i++) {
        signal(signals[i], handler);
    }
}

static void
stack_trace (char **args)
{
    pid_t pid;
    int in_fd[2], out_fd[2], idx, state;
    fd_set fdset;
    char buffer[4096];

    /* stop gdb from wrapping lines */
    snprintf(buffer, sizeof(buffer), "%u", (unsigned int)sizeof(buffer));
    setenv("COLUMNS", buffer, 1);

    if ((pipe(in_fd) == -1) || (pipe(out_fd) == -1)) {
        perror("unable to open pipe");
        _exit(0);
    }

    pid = fork();
    if (pid == 0) {
        /* double fork+_exit so we can properly detach from the parent
           process. this is important because some platforms (only OpenBSD for
           now) don't allow ptrace()ing their parent processes, which is what we
           need to be able to do to have a working gdb. */
        pid = fork();
        if (pid == 0) {
            char buf[16];
            /* just to be sure the kernel doesn't recognize us as an inferiour
               process */
            if (setsid() == (pid_t)-1) {
                perror("setsid failed");
                _exit(0);
            }

            close(0); dup(in_fd[0]);
            close(1); dup(out_fd[1]);
            close(2); dup(out_fd[1]);

            snprintf(buf, sizeof(buf), "%u\n", getpid());
            write(1, buf, strlen(buf));

            execvp(args[0], args);
            perror("exec failed");
            _exit(0);
        }
        else if (pid == (pid_t)-1) {
            perror("unable to fork");
            _exit(0);
        }
        else {
            _exit(0);
        }
    }
    else if (pid == (pid_t)-1) {
        perror("unable to fork");
        _exit(0);
    }

    FD_ZERO(&fdset);
    FD_SET(out_fd[0], &fdset);

    write(in_fd[1], "thread apply all backtrace\n", 27);
    write(in_fd[1], "quit\n", 5);

    idx = 0;
    state = 0;

    while (1) {
        pid_t gdb_pid;
        struct timeval tv;
        int sel;

        tv.tv_sec = 1;
        tv.tv_usec = 0;

        sel = select(FD_SETSIZE, &fdset, NULL, NULL, &tv);
        if (sel == -1)
            break;

        if ((sel > 0) && (FD_ISSET(out_fd[0], &fdset))) {
            char c;
            if (read(out_fd[0], &c, 1) > 0) {
                switch (state) {
                case 0:
                    state = 1;
                    idx = 0;
                    buffer[idx++] = c;
                    break;
                case 1:
                    buffer[idx++] = c;
                    if ((c == '\n') || (c == '\r')) {
                        buffer[idx] = 0;
                        gdb_pid = (pid_t)strtol(buffer, (char **)NULL, 10);
                        state = 2;
                        idx = 0;
                    }
                    break;
                case 2:
                    if (c == '#') {
                        state = 3;
                        idx = 0;
                        buffer[idx++] = c;
                    }
                    break;
                case 3:
                    buffer[idx++] = c;
                    if ((c == '\n') || (c == '\r')) {
                        buffer[idx] = 0;
                        write(1, buffer, strlen(buffer));
                        state = 2;
                        idx = 0;
                    }
                    break;
                default:
                    break;
                }
            }
        }
        else if (kill(gdb_pid, 0) < 0) {
            break;
        }
    }

    close(in_fd[0]);
    close(in_fd[1]);
    close(out_fd[0]);
    close(out_fd[1]);
    _exit(0);
}

static void
backtrace ()
{
    pid_t pid;
    char buf[16], *args[4];
    int status;

    snprintf(buf, sizeof(buf), "%u", (unsigned int)getpid());

    args[0] = gdb_path;
    args[1] = perl_path;
    args[2] = buf;
    args[3] = NULL;

    pid = fork();
    if (pid == 0) {
        stack_trace(args);
        _exit(0);
    }
    else if (pid == (pid_t)-1) {
        perror("unable to fork");
        return;
    }

    waitpid(pid, &status, 0);
}

static void
signal_handler (int sig) {
    PERL_UNUSED_ARG(sig);
    register_sighandler(SIG_DFL);
    backtrace();
    abort();
}

static void
register_segv_handler (char *gdb, char *perl)
{
    strncpy(gdb_path, gdb, sizeof(gdb_path));
    strncpy(perl_path, perl, sizeof(perl_path));
    register_sighandler(signal_handler);
}

#line 212 "bt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 356 "bt.c"

XS_EUPXS(XS_Devel__bt_register_segv_handler); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Devel__bt_register_segv_handler)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "gdb, perl");
    {
	char *	gdb = (char *)SvPV_nolen(ST(0))
;
	char *	perl = (char *)SvPV_nolen(ST(1))
;

	register_segv_handler(gdb, perl);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Devel__bt); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Devel__bt)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Devel::bt::register_segv_handler", XS_Devel__bt_register_segv_handler);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
